package java;

import java.io.*;

public class Pajek2Adj {

  public Pajek2Adj() {
    m_vertices_ignored = 15;
  }

  public void loadPajData(String fileName)
      throws IOException {
    BufferedReader file = new BufferedReader(new FileReader(fileName));
    String line = file.readLine();
    String splits[] = line.split(" +");
    m_total_vertices = Integer.parseInt(splits[splits.length - 1].trim()) - m_vertices_ignored;
    System.out.println((new StringBuilder()).append("Total nodes considered: ").append(m_total_vertices).toString());
    m_adj_mat = new float[m_total_vertices][m_total_vertices];
    degree = new int[m_total_vertices];
    file.readLine();
    file.readLine();
    do {
      if ((line = file.readLine()) == null) { break; }
      splits = line.trim().split(" +");
      int src = Integer.parseInt(splits[0].trim()) - 1;
      int dest = Integer.parseInt(splits[1].trim()) - 1;
      if (src < m_total_vertices && dest < m_total_vertices) {
        float weight = Float.parseFloat(splits[2].trim());
        m_adj_mat[src][dest] = m_adj_mat[dest][src] = weight;
        degree[src] += weight;
        degree[dest] += weight;
      }
    } while (true);
    file.close();
  }

  public void dump2File(String outAdjFile)
      throws IOException {
    BufferedWriter file = new BufferedWriter(new FileWriter(outAdjFile));
    int rowCount = 0;
    int maxColCount = 0;
    int iter = 1;
    for (int i = 0; i < m_total_vertices; i++) {
      int colCount = 0;
      for (int j = 0; j < m_total_vertices; j++) {
        colCount++;
        file.write((new StringBuilder()).append(m_adj_mat[i][j]).append(" ").toString());
      }

      if (colCount > maxColCount) {
        maxColCount = colCount;
        iter = i;
      }
      rowCount++;
      file.write("\n");
    }

    System.out.println((new StringBuilder()).append("Rows:").append(rowCount).toString());
    System.out.println((new StringBuilder()).append("MaxCols: ").append(maxColCount).append(" in col: ").append(iter).toString());
    file.flush();
    file.close();
  }

  public static void main(String args[])
      throws IOException {
    if (args.length != 2) {
      System.out.println("Usage: Pajek2Adj <input_pajek(net) file> <output_adj_mat_file>");
      System.exit(1);
    }
    Pajek2Adj obj = new Pajek2Adj();
    obj.loadPajData(args[0]);
    obj.dump2File(args[1]);
  }

  float m_adj_mat[][];
  int m_total_vertices;
  int degree[];
  int m_vertices_ignored;
}
